#include "slidelookat.h"

static const VECTOR4D gcvEye = { 0.0, 0.0, 0.0, 0.0 }; 
static const VECTOR4D gcvTarget = { 0.0, 0.0, -1.0, 0.0 }; 
static const VECTOR4D gcvUp = { 0.0, 1.0, 0.0, 0.0 }; 

//////////////////////////////////////////////////////////////////////
// CSLIDELookAt Class
//

CSLIDELookAt::CSLIDELookAt()
{
  m_vEye.Set(gcvEye);
  m_vTarget.Set(gcvUp);
  m_vUp.Set(gcvUp);
}

CSLIDELookAt::~CSLIDELookAt()
{
}

VOID CSLIDELookAt::Init(CHAR *pcFile, UINT_32 uiLine, 
			UINT_32 uiColumn)
{
  CSLIDETransform::Init(pcFile, uiLine, uiColumn);

  m_vEye.Set(gcvEye);
  m_vTarget.Set(gcvUp);
  m_vUp.Set(gcvUp);
}

VOID CSLIDELookAt::Uninit()
{
  CSLIDETransform::Uninit();
}

BOOL CSLIDELookAt::Initialized()
{
  return CSLIDETransform::Initialized();
}

BOOL CSLIDELookAt::CheckSemantics(CSLIDEWorld *pCSLIDEWorld)
{
  if ( !CSLIDETransform::CheckSemantics(pCSLIDEWorld) )
    {
      return FALSE;
    }

  return TRUE;
}

BOOL CSLIDELookAt::Valid()
{
  if ( !CSLIDETransform::Valid() )
    {
      return FALSE;
    }

  return TRUE;
}

VOID CSLIDELookAt::CheckDynamic()
{
  SetDynamic(m_vEye.GetDynamic() ||
	     m_vTarget.GetDynamic() ||
	     m_vUp.GetDynamic());
}

//////////////////////////////////////////////////////////////////////////////
// START: ASSIGNMENT 5: Fix this!!!
// 
VOID CSLIDELookAt::UpdateState()
{
  m_vEye.Update();
  m_vTarget.Update();
  m_vUp.Update();

  m_m.SetIdentity();        // ???
  m_mInverse.SetIdentity(); // ???
}
// 
// END  : ASSIGNMENT 5: Fix this!!!
//////////////////////////////////////////////////////////////////////////////

VOID CSLIDELookAt::WriteSLIDE(FILE *fpOutputFile)
{
  ASSERT( fpOutputFile != NULL );

  fprintf(fpOutputFile, "    %s\n", 
	  gcppcSLIDEReservedWords[sliderwtLookAt]);

  fprintf(fpOutputFile, "      %s ( %.3f %.3f %.3f )\n", 
	  gcppcSLIDEReservedWords[sliderwtEye],
	  m_vEye[X], m_vEye[Y], m_vEye[Z]);

  fprintf(fpOutputFile, "      %s ( %.3f %.3f %.3f )\n", 
	  gcppcSLIDEReservedWords[sliderwtTarget],
	  m_vTarget[X], m_vTarget[Y], m_vTarget[Z]);

  fprintf(fpOutputFile, "      %s ( %.3f %.3f %.3f )\n", 
	  gcppcSLIDEReservedWords[sliderwtUp],
	  m_vUp[X], m_vUp[Y], m_vUp[Z]);

  fprintf(fpOutputFile, "    %s\n", 
	  gcppcSLIDEReservedWords[sliderwtEndLookAt]);
}
